package com.simuwang.daq.service;

import cn.hutool.core.map.MapUtil;
import cn.hutool.core.util.StrUtil;
import com.simuwang.base.pojo.dos.CoreMailFolderDTO;
import com.simuwang.base.pojo.dto.EmailContentInfoDTO;
import com.simuwang.base.pojo.dto.MailboxInfoDTO;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Service
public class ReadEmailService {

    private static final Logger log = LoggerFactory.getLogger(ReadEmailService.class);
    private final CoreMailApiService coreMailApiService;

    public ReadEmailService(CoreMailApiService coreMailApiService) {
        this.coreMailApiService = coreMailApiService;
    }

    /**
     * 通过接口获取邮件
     *
     * @param mailboxInfoDTO 邮箱账号密码
     * @param emailTypeMap   邮箱类型映射表
     * @param startDate      开始日期
     * @param endDate        结束日期
     * @return 邮件信息
     */
    public Map<String, List<EmailContentInfoDTO>> readEmail(MailboxInfoDTO mailboxInfoDTO, Map<Integer, List<String>> emailTypeMap, Date startDate, Date endDate) {
        String account = mailboxInfoDTO.getAccount();
        String password = mailboxInfoDTO.getPassword();
        // 获取token
        String token = coreMailApiService.login(account, password);
        if (StrUtil.isBlank(token)) {
            log.error("邮箱登录失败, 无法获取到token");
            return MapUtil.newHashMap();
        }
        // 获取邮箱文件夹(默认只读取收件箱Inbox的邮件)
        List<CoreMailFolderDTO> mailFolderList = coreMailApiService.getAllFolders(token);

        // 获取邮件id

        // 根据邮件id获取邮件内容

        return MapUtil.newHashMap();
    }

}
